package br.usp.ime.coed.DEFSupport;

import java.awt.Graphics2D;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;

/**
 * Any object that can be drawed.
 */
public interface DrawingElement
///////////////////////////////
{
  /**
   * Returns the x position of this object relative to its container.
   *
   * @return
   */
  double getX();
  //////////////

  /**
   * Returns the y position of this object relative to its container.
   *
   * @return
   */
  double getY();
  //////////////

  /**
   * Sets the position to (dx,dy).
   *
   * @param dx
   * @param dy
   */
  void setPosition( double x, double y );
  ///////////////////////////////////////


  /**
   * Returns the minimal Rectangle enclosing its geometry.
   *
   * @return
   */
  Rectangle2D getBounds();
  ////////////////////////

  /**
   * Informs if the geometry of thid object includes the specified point.
   *
   * @param p
   * @return
   */
  boolean contains( Point2D p );

  /**
   * Draws this obhect in g.
   *
   * @param g
   */
  void paintOn( Graphics2D g );
  /////////////////////////////
}