package br.usp.ime.coed.DEFSupport;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Stroke;
import java.awt.geom.Rectangle2D;
import java.util.Iterator;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class DrawingElementSelector {

  private AbstractDrawingElementFinderClient client;
  private Point start, end;
  private Point previousEnd;
  private Stroke selectionStroke;


  public DrawingElementSelector(AbstractDrawingElementFinderClient client){
    this.client = client;
    selectionStroke = new BasicStroke(2.5F, BasicStroke.CAP_SQUARE,
                                      BasicStroke.JOIN_MITER, 1.0F,
                                      new float[]{8, 8}, 2.0F);

  }

  public void startSelection(Point p){
    start = p;
    client.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
  }

  public void keepSelecting(Point p){
    previousEnd = end;
    end = p;

  }

  public void drawSelectionOn( Graphics2D g2){

    Color oldColor = g2.getColor();
    Stroke oldStroke = g2.getStroke();
    g2.setColor(SelectionDisplayer.SELECTION_COLOR);
    g2.setStroke(selectionStroke);

    g2.drawRect(start.x, start.y, end.x - start.x, end.y -start.y);
    g2.drawRect(start.x, end.y, end.x - start.x, start.y - end.y);
    g2.drawRect(end.x, start.y, start.x - end.x, end.y -start.y);
    g2.drawRect(end.x, end.y, start.x - end.x, start.y - end.y);

    g2.setColor(oldColor);
    g2.setStroke(oldStroke);

  }

  public void endSelection(){

    double selectionMinX = Math.min(start.x, end.x),
        selectionMaxX = Math.max(start.x, end.x),
        selectionMinY = Math.min(start.y, end.y),
        selectionMaxY = Math.max(start.y, end.y);

    client.repaint();
    Iterator i = client.getDrawingElements();
    while(i.hasNext()){
      DrawingElement de = (DrawingElement)i.next();
      Rectangle2D bounds = de.getBounds();
      double minX = bounds.getMinX(), maxX = bounds.getMaxX(),
          minY = bounds.getMinY(), maxY = bounds.getMaxY();
      if(((selectionMinX <= minX && selectionMaxX >= minX) ||
         (selectionMinX <= maxX && selectionMaxX >= maxX) ||
         (selectionMinX >= minX && selectionMaxX <= maxX)) &&
          ((selectionMinY <= minY && selectionMaxY >= minY)||
          (selectionMinY <= maxY && selectionMaxY >= maxY) ||
          (selectionMinY >= minY && selectionMaxY <= maxY))){
          client.select(de);
      }

    }
    start = null;
    client.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
  }

  public boolean isSelecting(){
    return start != null && end != null;
  }


}