/*
 * Criado em 22/10/2004
 */
package br.usp.ime.coed.action.addMenu;

import java.awt.event.ActionEvent;

import br.usp.ime.coed.action.FormattedAction;
import br.usp.ime.coed.behaviour.CreateIconBehaviour;
import br.usp.ime.coed.model.ComponentType;
import br.usp.ime.coed.view.ApplicationView;
import br.usp.ime.coed.view.GraphicPane;
import br.usp.ime.coed.view.TabbedPane;

/**
 * @author Andr Yoshiaki Kashiwabara <yoshiaki@vision.ime.usp.br>
 */
public class AddAction extends FormattedAction {
	ComponentType type;

	ApplicationView view;

	/**
	 * @param type
	 * @param view
	 */
	public AddAction(ComponentType type, ApplicationView view) {
		super(type.getName(), type.getIconButtonFileName());
		this.type = type;
		this.view = view;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {
		try {
			TabbedPane tabPane = view.getTabPane();
			GraphicPane pane = tabPane.getSelectedGraphicPane();
			pane.getDrawingElementFinder().setDEFBehaviour(
					new CreateIconBehaviour(view, type), true);
			view.setStatus(" ");
			view.setAllActionEnable(false);
		} catch (IllegalAccessError error) {
			view.setStatus(error.getMessage());
		}

	}

}