/*
 * Criado em 22/10/2004
 */
package br.usp.ime.coed.action.fileMenu;

import java.awt.event.ActionEvent;
import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import br.usp.ime.coed.action.FormattedAction;
import br.usp.ime.coed.model.ApplicationModel;
import br.usp.ime.coed.utils.CoedFileView;
import br.usp.ime.coed.utils.EGeneFilesFilter;
import br.usp.ime.coed.view.ApplicationView;

/**
 * @author Andr? Yoshiaki Kashiwabara <yoshiaki@vision.ime.usp.br>
 */
public class ExportEGeneConfigurationAction extends FormattedAction {

    ApplicationView view;

    public ExportEGeneConfigurationAction(ApplicationView view) {
        super("Export", 'e');
        this.view = view;
    }

    /*
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
        ApplicationModel model = view.getApplicationModel();
        view.setStatus("Exporting ...");
        JFileChooser fileChooser = new JFileChooser(".");
        String file = null;
        String path = null;
        fileChooser.setName("Saving a .cnf file");
        fileChooser.setApproveButtonMnemonic('s');
        fileChooser.setAcceptAllFileFilterUsed(false);

        fileChooser.setFileView(new CoedFileView());

        fileChooser.setFileFilter(new EGeneFilesFilter());

        int returnVal = fileChooser.showSaveDialog(view);
        if (returnVal == JFileChooser.APPROVE_OPTION) {

            path = fileChooser.getSelectedFile().getParent();

            file = fileChooser.getSelectedFile().getName();

            if (!file.endsWith(".cnf"))
                file += ".cnf";
            if (model.getDocManager().getCurrentDocument().getFirstComponent() == null) {
                JOptionPane.showMessageDialog(view,
                        "Your pipeline is not complete.\n"
                                + "Please, choose a component as the first "
                                + "process and try again.");
                view.setStatus("Action canceled.");
                return;

            }

            if ((new File(path + "/" + file)).exists()) {
                int result = JOptionPane.showConfirmDialog(view,
                        "The file you choose already exists."
                                + "Do you want to override this file?",
                        "REALLY ?", JOptionPane.YES_NO_OPTION);
                if (result != JOptionPane.YES_OPTION) {
                    view.setStatus("Action canceled.");
                    return;
                }
            }

            try {
                model.getDocManager().saveAsEGeneDocument(path, file);
                view.setStatus("The document " + path + "/" + file
                        + " was saved");
            } catch (Exception exc) {
                view.setStatus("Cant save document " + exc.getMessage());
            }
        } else if (returnVal == JFileChooser.CANCEL_OPTION) {
            view.setStatus("Cancel button clicked.");
            return;
        }

    }
}