/*
 * Criado em 22/10/2004
 */
package br.usp.ime.coed.action.fileMenu;

import java.awt.event.ActionEvent;

import javax.swing.JFileChooser;

import br.usp.ime.coed.action.FormattedAction;
import br.usp.ime.coed.model.ApplicationModel;
import br.usp.ime.coed.utils.EGeneFilesFilter;
import br.usp.ime.coed.view.ApplicationView;

/**
 * @author Andr? Yoshiaki Kashiwabara <yoshiaki@vision.ime.usp.br>
 */
public class ImportEGeneConfigurationAction extends FormattedAction {
    ApplicationView view;

    public ImportEGeneConfigurationAction(ApplicationView view) {
        super("Import", 'i');
        this.view = view;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
        ApplicationModel model = view.getApplicationModel();
        view.setStatus("Importing ...");
        JFileChooser fileChooser = new JFileChooser(".");
        String file = null;
        String path = null;
        fileChooser.setName("Choose a EGene (.cnf) file...");
        fileChooser.setApproveButtonMnemonic('o');
        fileChooser.setAcceptAllFileFilterUsed(false);

        fileChooser.setFileFilter(new EGeneFilesFilter());

        int returnVal = fileChooser.showOpenDialog(view);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            path = fileChooser.getSelectedFile().getParent();
            file = fileChooser.getSelectedFile().getName();
        } else if (returnVal == JFileChooser.CANCEL_OPTION) {
            view.setStatus("Cancel button clicked.");
            return;
        }
        
        try {
            model.getDocManager().openEGeneDocument(path, file);
            model.getDocManager().getDocumentCareTaker(model.getDocManager().getCurrentDocument()).notifyActive();
            view.setStatus("The egene configuration " + path + "/" + file + " was opened");
        } catch (Exception exc) {
            exc.printStackTrace();
            view.setStatus("Cant open document, " + exc.getMessage());
        }
        model.getDocManager().getCurrentDocument().setNotSaved(true);
    }

}