/*
 * Criado em 22/10/2004
 */
package br.usp.ime.coed.action.fileMenu;

import java.awt.event.ActionEvent;
import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import br.usp.ime.coed.Main;
import br.usp.ime.coed.action.FormattedAction;
import br.usp.ime.coed.model.ApplicationModel;
import br.usp.ime.coed.model.CoedDocument;
import br.usp.ime.coed.model.CoedDocumentManager;
import br.usp.ime.coed.utils.CoedFilesFilter;
import br.usp.ime.coed.view.ApplicationView;

/**
 * @author Andr Yoshiaki Kashiwabara <yoshiaki@vision.ime.usp.br>
 */
public class NewFileAction extends FormattedAction {
    ApplicationView view;

    public NewFileAction(ApplicationView view) {
        super("New", 'n', Main.getInstance().getEgeneDir()
                + "/images/file/new.gif");
        this.view = view;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
        ApplicationModel model = view.getApplicationModel();
        view.setStatus("Creating new document ...");
        JFileChooser fileChooser = new JFileChooser(".");
        String file = null;
        String path = null;
        fileChooser.setName("Creating a new document...");
        fileChooser.setApproveButtonMnemonic('n');
        fileChooser.setAcceptAllFileFilterUsed(false);

        fileChooser.setFileFilter(new CoedFilesFilter());

        int returnVal = fileChooser.showDialog(view, "New");

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            path = fileChooser.getSelectedFile().getParent();
            file = fileChooser.getSelectedFile().getName();
            if (!file.endsWith(".gen"))
                file = file + ".gen";

            if ((new File(path + "/" + file)).exists()) {
                int result = JOptionPane.showConfirmDialog(view,
                        "The file you choose already exists."
                                + "Do you want to override this file?",
                        "REALLY ?", JOptionPane.YES_NO_OPTION);
                if (result != JOptionPane.YES_OPTION) {
                    view.setStatus("Action canceled.");
                    return;
                }
            }
        } else if (returnVal == JFileChooser.CANCEL_OPTION) {
            view.setStatus("Cancel button clicked.");
            return;
        } else {
            view.setStatus("Duh .");
            return;
        }
        CoedDocumentManager manager = model.getDocManager();
        try {
            manager.newDocument(path, file);
        } catch (IllegalStateException ise) {
            view.setStatus(ise.getMessage());
        }
        CoedDocument doc = model.getDocManager().getCurrentDocument();
        view.setStatus("Document "
                + model.getDocManager().getCurrentDocument().getName()
                + " was created !");
    }

}