/*
 * Created on Oct 27, 2004
 */
package br.usp.ime.coed.action.iconElement;

import java.awt.event.ActionEvent;

import javax.swing.Box;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

import br.usp.ime.coed.action.FormattedAction;
import br.usp.ime.coed.model.CoedDocument;
import br.usp.ime.coed.view.ApplicationView;
import br.usp.ime.coed.view.GraphicalIconElement;

/**
 * @author yoshiaki Action used when the user wants to change the graphical icon
 *         element position.
 */
public class ChooseAsFirstComponent extends FormattedAction {

	GraphicalIconElement icon;

	ApplicationView view;

	public ChooseAsFirstComponent(ApplicationView view) {
		super("Choose as first process", "c");
		this.view = view;
	}

	/*
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {
		view.getApplicationModel().getDocManager().saveCurrentDocumentState();
		CoedDocument document = view.getApplicationModel().getDocManager()
				.getCurrentDocument();

		Box pipelineBox = Box.createHorizontalBox(), boxY = Box
				.createHorizontalBox();
		pipelineBox.add(new JLabel("Pipeline name: "));
		JTextField pipeNameField = new JTextField();
		pipelineBox.add(pipeNameField);
		pipeNameField.setText("" + document.getPipelineName());
		Box positionBox = Box.createVerticalBox();
		positionBox.add(pipelineBox);

		int result = JOptionPane.showOptionDialog(view, positionBox,
				"Set pipeline name", JOptionPane.OK_CANCEL_OPTION,
				JOptionPane.PLAIN_MESSAGE, null, null, null);

		if (result == JOptionPane.CANCEL_OPTION)
			return;
		document.setPipelineName(pipeNameField.getText());
		view.getApplicationModel().getDocManager().saveCurrentDocumentState();
		document.setFirstComponent(icon.getComponent());

	}

	/**
	 * @param icon
	 *            The icon to set.
	 */
	public void setIcon(GraphicalIconElement icon) {
		this.icon = icon;
	}
}