/*
 * Created on Oct 27, 2004
 */
package br.usp.ime.coed.action.iconElement;

import java.awt.event.ActionEvent;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import br.usp.ime.coed.DEFSupport.DrawingElement;
import br.usp.ime.coed.action.FormattedAction;
import br.usp.ime.coed.model.CoedDocument;
import br.usp.ime.coed.model.CoedDocumentManager;
import br.usp.ime.coed.model.Component;
import br.usp.ime.coed.view.ApplicationView;
import br.usp.ime.coed.view.GraphicalIconElement;

/**
 * @author yoshiaki Action used when the user wants to change the graphical icon
 *         element position.
 */
public class DeletePipelinesAction extends FormattedAction {

	DrawingElement icon;

	ApplicationView view;

	public DeletePipelinesAction(ApplicationView view) {
		super("Delete internal pipelines", "p");
		this.view = view;
	}

	/*
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {
	    CoedDocumentManager manager = view.getApplicationModel().getDocManager();
	    CoedDocument document = manager.getCurrentDocument();
	    Set selectedGraphicalElement = view.getTabPane().getSelectedGraphicPane().getSelection().getSelectedElements();
	    Set selectedComponents = new HashSet();
	    manager.saveCurrentDocumentState();
	    Iterator it = selectedGraphicalElement.iterator();
	    while(it.hasNext()){
	        GraphicalIconElement de =  ((GraphicalIconElement) it.next());
	        de.getComponent().isSelected(false);
	        selectedComponents.add(de.getComponent());
	    }
	    
	    it = selectedComponents.iterator();
	    while(it.hasNext()){
	        Component c = (Component) it.next();
	        if(selectedComponents.containsAll(c.getNextComponents())){
	            document.removeOutcomePipe(c);
	        }
	    }
	    
	}

	/**
	 * @param icon The icon to set.
	 */
	public void setIcon(DrawingElement icon) {
		this.icon = icon;
	}
}