/*
 * Criado em 23/10/2004
 */
package br.usp.ime.coed.action.pipe;

import java.awt.event.ActionEvent;

import br.usp.ime.coed.Main;
import br.usp.ime.coed.action.FormattedAction;
import br.usp.ime.coed.behaviour.CreatePipeBehaviour;
import br.usp.ime.coed.model.ApplicationModel;
import br.usp.ime.coed.view.ApplicationView;
import br.usp.ime.coed.view.GraphicPane;
import br.usp.ime.coed.view.TabbedPane;

/**
 * @author Andr Yoshiaki Kashiwabara <yoshiaki@vision.ime.usp.br>
 */
public class AddPipeAction extends FormattedAction {

	ApplicationModel model;

	ApplicationView view;

	public AddPipeAction(ApplicationModel model, ApplicationView view) {
		super("Add pipe", 'a', Main.getInstance().getEgeneDir()
				+ "/images/addPipe_button.gif");
		this.model = model;
		this.view = view;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {
		try {
			TabbedPane tabPane = view.getTabPane();
			GraphicPane pane = tabPane.getSelectedGraphicPane();
			pane.getDrawingElementFinder().setDEFBehaviour(
					new CreatePipeBehaviour(view, pane), true);
			view.setStatus("use right mouse button to cancel this action.");
			view.setAllActionEnable(false);
		} catch (IllegalAccessError error) {
			view.setStatus(error.getMessage());
		}

	}

}