package br.usp.ime.coed.behaviour;

import java.awt.Cursor;
import java.awt.event.MouseEvent;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;

import javax.swing.JOptionPane;

import br.usp.ime.coed.ReadEgeneConfiguration;
import br.usp.ime.coed.DEFSupport.DEFBehaviour;
import br.usp.ime.coed.model.ComponentType;
import br.usp.ime.coed.view.ApplicationView;
import br.usp.ime.coed.view.GraphicPane;
import br.usp.ime.coed.view.GraphicalIconElement;
import br.usp.ime.coed.view.IconValuesForm;

/**
 * This behaviour is created when the user requests an icon creation.
 */
public class CreateIconBehaviour implements DEFBehaviour {
    GraphicPane pane;

    GraphicalIconElement dummyIcon;

    ComponentType type;

    ApplicationView view;

    public CreateIconBehaviour(ApplicationView view, ComponentType type) {
        this.pane = view.getTabPane().getSelectedGraphicPane();
        this.type = type;
        this.view = view;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.awt.event.MouseListener#mouseClicked(java.awt.event.MouseEvent)
     */
    public void mouseClicked(MouseEvent e) {
        pane.drawingElementEndDrag();
        pane.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        pane.getDrawingElementFinder().setDEFBehaviour(
                new CoedDefaultBehaviour(view), true);
        pane.setCursor(new Cursor(Cursor.WAIT_CURSOR));
        GraphicalIconElement element = new GraphicalIconElement((int) e.getX(),
                (int) e.getY(), type, pane);
       
        if (element.getComponent().getType() == ReadEgeneConfiguration
                .getInstance().getNullType()) {
            JOptionPane.showMessageDialog(view,"Invalid component type, delete it and put a valid one.");
            view.setStatus("Action canceled. " + "Invalid component type, delete it and put a valid one.");
            return;
        }
        new IconValuesForm(element, view);
        
        pane.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.awt.event.MouseListener#mouseEntered(java.awt.event.MouseEvent)
     */
    public void mouseEntered(MouseEvent e) {
        dummyIcon = new GraphicalIconElement(-50, -50, type, pane);
        Rectangle2D bounds = dummyIcon.getBounds();
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.awt.event.MouseListener#mouseExited(java.awt.event.MouseEvent)
     */
    public void mouseExited(MouseEvent e) {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see java.awt.event.MouseListener#mousePressed(java.awt.event.MouseEvent)
     */
    public void mousePressed(MouseEvent e) {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see java.awt.event.MouseListener#mouseReleased(java.awt.event.MouseEvent)
     */
    public void mouseReleased(MouseEvent e) {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see java.awt.event.MouseMotionListener#mouseDragged(java.awt.event.MouseEvent)
     */
    public void mouseDragged(MouseEvent e) {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see java.awt.event.MouseMotionListener#mouseMoved(java.awt.event.MouseEvent)
     */
    public void mouseMoved(MouseEvent e) {
        Point2D currentPoint = e.getPoint();
        dummyIcon.setPosition(currentPoint.getX(), currentPoint.getY());
        pane.drawingElementDragged(dummyIcon, e);
    }

}